package jeliot.gui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;

import javax.swing.*; 
import javax.swing.event.*; 
import javax.swing.text.*;

import jeliot.parser.*;
import jeliot.theatre.*;
import jeliot.gui.*;

/** This is the component that shows and highlightd the program while 
  * Jeliot is animating.
  *
  * @author Pekka Uronen
  *
  * created         10.8.1999
  */
public class CodePane extends JComponent {

    JTextArea area = new JTextArea();
    {
        area.setMargin(new Insets(10, 10, 10, 10));
        area.setFont(new Font("Courier", Font.PLAIN, 12));
        area.setTabSize(4);
        area.setBackground(new Color(0xFFF8F0));
        area.setSelectionColor(new Color(0x990000));
        area.setSelectedTextColor(Color.white);
        area.setEditable(false);
        
    }

    
    public CodePane() {
        setLayout(new BorderLayout());
        add("Center", new JScrollPane(area));
    }

    
    public void installProgram(PCompilationUnit program, String text) {
        area.setText(text);
    }

    
    public void highlightStatement(final int left, final int right) {
        Runnable updateAComponent = new Runnable() {
            public void run() {
                
                // +1 is a kludge! Should be fixed in the P-classes.
                area.select(left, right+1);
            }
        };
        SwingUtilities.invokeLater(updateAComponent);
    }

    
}
