package jeliot.lang;

import java.util.*;
import jeliot.parser.*;
import jeliot.FeatureNotImplementedException;

/**
  * @author Pekka Uronen
  *
  * created         27.9.1999
  */
public abstract class ReferenceType extends Type {
    
    public static ReferenceType ObjectTYPE 
            = ForeignType.getType(Object.class);
    public static ReferenceType StringTYPE 
            = ForeignType.getType(String.class);
    public static ReferenceType CloneableTYPE 
            = ForeignType.getType(Cloneable.class);
            
    public boolean isInterface() {
        return false;
    }
    
    public abstract MethodPointer getMethod(String name, Type[] argt);
    
    /** Returns a constructor pointer to a constructor with arguments
      * of given types.
      */
    public ConstructorPointer getConstructor(Type[] argt) {
        return null;
    }
    
    public abstract FieldPointer getField(String name);
    
    public String getSimpleName() {
        return toString();
    }
    
    public Value neutralValue() {
        return new Value(this, null);
    }
     
}

    
