package jeliot.parser;

import java.util.*;

/**
  * .
  *
  * @author Pekka Uronen
  *
  * created         8.8.1999
  * last modified   8.8.1999
  */
public class LocalVariableBundle extends Hashtable {

    private Stack varStack = new Stack();
    private Stack stateStack = new Stack();

    private int maxCount;

    public void put(PVariableDeclarator v) throws SemanticException {
        String name = v.getIdentifier();
        PVariableDeclarator old = (PVariableDeclarator)put(name, v);
        if (old != null) {
            throw new SemanticException(
                "Double declaration of a local variable: "+name);
        }
        varStack.push(name);
        maxCount = Math.max(maxCount, varStack.size());
    }

    public void saveState() {
        int state = varStack.size();
        stateStack.push(new Integer(state));
    }

    public void resumeState() {
        int state = ((Integer)stateStack.pop()).intValue();
        for (int i = varStack.size(); i > state; --i) {
            String name = (String)varStack.pop();
            remove(name);
        }
    }

    public int getMaximumCount() {
        return maxCount;
    }
}
