package jeliot.parser;

import java.util.*;
import jeliot.parser.error.*;
import jeliot.lang.*;
import jeliot.theatre.*;
import jeliot.FeatureNotImplementedException;

/**
  *
  * @author Pekka Uronen
  *
  * created         30.9.1999
  */
public class PInstanceCreation extends PExpression {
    
    private Vector arguments;
    private PType ptype;
    private ConstructorPointer cpoint;
    
    public PInstanceCreation(PType ptype, Vector arguments) {
        this.ptype = ptype;
        this.arguments = arguments;
        setParents(arguments);
    }
    
    public void acceptVisitor(ProgramTreeVisitor visitor) {
        visitor.enterInstanceCreation(this);
        if (arguments != null) {
            Enumeration enum = arguments.elements();
            while (enum.hasMoreElements()) {
                PExpression e = (PExpression)enum.nextElement();
                e.acceptVisitor(visitor);
            }
        }
        visitor.leaveInstanceCreation(this);   
    }
    
    public void typeCheck(
            LocalVariableBundle locals,
            NameSpace space,
            PClass myClass) {
                
        ReferenceType type = (ReferenceType)ptype.
                resolveType(space, myClass);
        setType(type);
        Type[] argt = new Type[
                (arguments == null) ?
                        0:
                        arguments.size()];
        try {
            this.cpoint = type.getConstructor(argt);
        }
        catch (NonexistentConstructorException e) {
            e.setInstanceCreation(this);
            throw (e);
        }
    } 
    
}
    
    