package jeliot.parser;

import java.util.*;
import jeliot.lang.*;
import jeliot.theatre.*;
import jeliot.FeatureNotImplementedException;

/**
  * PStatement represents a single (empty) statement.
  *
  * @author Pekka Uronen
  *
  * created         6.8.1999
  * last modified   15.8.1999
  */
public class PStatement extends PElement {

    private PLabel label;

    protected PStatement(int left, int right) {
        super(left,right);
    }

    public PStatement() { }

    /** Constructor for inner class declaration statement. */
    public PStatement(PClass myClass) throws FeatureNotImplementedException {
        throw new FeatureNotImplementedException("Inner Classes");
    }

    /** Constructor for inner interface declaration statement. */
    public PStatement(PInterface myInterface) throws FeatureNotImplementedException {
        throw new FeatureNotImplementedException("Inner interfaces");
    }

    /** For making empty statements */
    public static PStatement getEmptyStatement() {
        return new PStatement();
    }

    /** Sets the label preceeding this statement */
    public void setLabel(PLabel label) {
        this.label = label;
    }

    public void acceptVisitor(ProgramTreeVisitor visitor) { }

    void dump(java.io.PrintStream out, String indent) {
        out.println(indent + "Statement: " + this);
    }
    
    void execute(Director director) throws Return {
        director.atStatement(this);
    }

    public String statementName() {
        return "empty statement";
    }

}
