package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * IllegalArrayAccessException is thrown when a type checker finds that
  * the compile time type of a variable accessed with array access
  * expression is not an array.
  * 
  * @author Pekka Uronen
  *
  * created         30.9.1999
  */
public class IllegalArrayAccessException extends SemanticException {
    
    private PArrayAccess access;
    private Type type;
    
    public IllegalArrayAccessException(Type t, 
            PArrayAccess access) {
        
        this.access = access;
        this.type = t;
    }
    
    public String toString() {
         String typeStr = type.toString();
         String varName = access.getIdentifier();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>Illegal array access.</H1>\n" +
            "<P>" +
            "Your program tries to access variable <B>" +
            varName + "</B> of type <B>" + typeStr + "</B> " +
            "as if it was an array. "+
            "</BODY></HTML>"
            );
    }
    
}