package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/** 
  * @author Pekka Uronen
  *
  * created         30.9.1999
  */
public class IllegalCastException extends SemanticException {
    
    private PCastExpression cast;
    
    public IllegalCastException(PCastExpression cast) {
        this.cast = cast;
    }
    
    public String toString() {
        
        PExpression arg = cast.getArgument();
        Type origType = arg.getType();
        
        Type castType = cast.getType();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>Illegal cast.</H1>\n" +
            "<P>" +
            "Your program tries to cast a value of type" +
            "<B>" + origType + "</B> " +
            "to " +
            "<B>" + castType + "</B>.\n" +
            "This is not a good thing. "+
            "</BODY></HTML>"
            );
    }
 
}